Groovy 1.7.0

## groovy.beans
Class BindableASTTransformation

    java.lang.Object
      groovy.beans.BindableASTTransformation

All Implemented Interfaces:
  ASTTransformation

    @GroovyASTTransformation(phase= CompilePhase.CANONICALIZATION)
    class BindableASTTransformation
    extends Object

Handles generation of code for the `@Bindable` annotation when `@Vetoable` is not present.

Generally, it adds (if needed) a PropertyChangeSupport field and the needed add/removePropertyChangeListener methods to support the listeners.

It also generates the setter and wires the setter through the PropertyChangeSupport.

If a Vetoable annotaton is detected it does nothing and lets the VetoableASTTransformation handle all the changes.

author:
  Danno Ferrin (shemnon)

author:
  Chris Reeves

Field Summary
`protected static ClassNode` | `boundClassNode`
`protected ClassNode` | `pcsClassNode`

Constructor Summary
`BindableASTTransformation()`

Method Summary
`protected void` | `addPropertyChangeSupport(ClassNode declaringClass)` Adds the necessary field and methods to support property change support.
`protected Statement` | `createBindableStatement(PropertyNode propertyNode, Expression fieldExpression)` Creates a statement body similar to: `this.firePropertyChange("field", field, field = value)`
`protected void` | `createSetterMethod(ClassNode declaringClass, PropertyNode propertyNode, String setterName, Statement setterBlock)` Creates a setter method with the given body.
`static boolean` | `hasBindableAnnotation(AnnotatedNode node)` Convenience method to see if an annotated node is {
`protected boolean` | `needsPropertyChangeSupport(ClassNode declaringClass, SourceUnit sourceUnit)` Snoops through the declaring class and all parents looking for methods void addPropertyChangeListener(PropertyChangeListener), void removePropertyChangeListener(PropertyChangeListener), and void firePropertyChange(String, Object, Object).
`void` | `visit(ASTNode[] nodes, SourceUnit source)` Handles the bulk of the processing, mostly delegating to other methods.

Methods inherited from class Object
wait, wait, wait, hashCode, getClass, equals, toString, notify, notifyAll

Field Detail

### boundClassNode

    protected static ClassNode boundClassNode

### pcsClassNode

    protected ClassNode pcsClassNode

Constructor Detail

### BindableASTTransformation

    BindableASTTransformation()

Method Detail

### addPropertyChangeSupport

    protected void addPropertyChangeSupport(ClassNode declaringClass)

  Adds the necessary field and methods to support property change support.

  Adds a new field: `protected final java.beans.PropertyChangeSupport this$PropertyChangeSupport = new java.beans.PropertyChangeSupport(this)`"

  Also adds support methods: `public void addPropertyChangeListener(java.beans.PropertyChangeListener)` `public void addPropertyChangeListener(String, java.beans.PropertyChangeListener)` `public void removePropertyChangeListener(java.beans.PropertyChangeListener)` `public void removePropertyChangeListener(String, java.beans.PropertyChangeListener)` `public java.beans.PropertyChangeListener[] getPropertyChangeListeners()`
  param:
    declaringClass the class to which we add the support field and methods

### createBindableStatement

    protected Statement createBindableStatement(PropertyNode propertyNode, Expression fieldExpression)

  Creates a statement body similar to: `this.firePropertyChange("field", field, field = value)`
  param:
    propertyNode the field node for the property
  param:
    fieldExpression a field expression for setting the property value
  return:
    the created statement

### createSetterMethod

    protected void createSetterMethod(ClassNode declaringClass, PropertyNode propertyNode, String setterName, Statement setterBlock)

  Creates a setter method with the given body.
  param:
    declaringClass the class to which we will add the setter
  param:
    propertyNode the field to back the setter
  param:
    setterName the name of the setter
  param:
    setterBlock the statement representing the setter block

### hasBindableAnnotation

    public static boolean hasBindableAnnotation(AnnotatedNode node)

  Convenience method to see if an annotated node is `@Bindable`.
  param:
    node the node to check
  return:
    true if the node is bindable

### needsPropertyChangeSupport

    protected boolean needsPropertyChangeSupport(ClassNode declaringClass, SourceUnit sourceUnit)

  Snoops through the declaring class and all parents looking for methods void addPropertyChangeListener(PropertyChangeListener), void removePropertyChangeListener(PropertyChangeListener), and void firePropertyChange(String, Object, Object). If any are defined all must be defined or a compilation error results.
  param:
    declaringClass the class to search
  param:
    sourceUnit the source unit, for error reporting. `@NotNull`.
  return:
    true if property change support should be added

### visit

    public void visit(ASTNode[] nodes, SourceUnit source)

  Handles the bulk of the processing, mostly delegating to other methods.
  param:
    nodes the ast nodes
  param:
    source the source unit for the nodes

Copyright © 2003-2009 The Codehaus. All rights reserved.